package com.herdt.javxml.kap05;

import org.xml.sax.*;
import org.xml.sax.helpers.*;
import java.io.*;

public class Uebung1 extends DefaultHandler
{
  XMLReader xml_reader;
  static boolean docOK = true;

  public Uebung1()
  {
    try
    {
      xml_reader = XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");
      xml_reader.setFeature("http://xml.org/sax/features/validation", true);
      xml_reader.setFeature("http://apache.org/xml/features/validation/schema", true);
      xml_reader.setFeature("http://apache.org/xml/features/validation/dynamic", true);
      xml_reader.setContentHandler(this);
      xml_reader.setErrorHandler(this);
      InputSource is = new InputSource("com\\herdt\\javxml\\kap05\\Uebung1.xml");
      xml_reader.parse(is);
    }
    catch(SAXException saxe)
    {
      System.out.println("!  ---  Fehler beim Parsen  ---  !");
      docOK = false;
    }
    catch(IOException ioe)
    {
      System.out.println("E/A-Fehler: " + ioe.getMessage());
      docOK = false;
    }
  }

  public static void main(String[] args)
  {
    new Uebung1();
    if(docOK)
    {
      System.out.println("\n *** Inhalt der Dokuments ***\n");
      System.out.println(doc);
    }
  }

  // ContentHandler
  int tab = 0;
  private boolean hatZeichen = false;
  static StringBuffer doc = new StringBuffer();
  
  public void processingInstruction(String target, String data) throws SAXException
  {
    doc.append("<?" + target + data + "?>\n");
  }
  public void startElement(String namespaceURI, String localName, String qName, Attributes atts) throws SAXException
  {
    doc.append("<" + localName + "> ");
    for(int i = 0; i < atts.getLength(); i++)
      doc.append(atts.getLocalName(i) + " = " + atts.getValue(i) + " ");
  }
  public void endElement(String namespaceURI, String localName, String qName) throws SAXException
  {
    doc.append("<" + localName + ">");
  }
  public void characters(char[] ch, int start, int length) throws SAXException
  {
    doc.append(new String(ch, start, length) + " ");
  }
  //ErrorHandler
  public void warning(SAXParseException ex)
  {
    System.out.println("\n! Warnung: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
  public void error(SAXParseException ex)
  {
    System.out.println("\n! ! Fehler: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
  public void fatalError(SAXParseException ex)
  {
    System.out.println("\n! ! ! schwerer Fehler: " + ex.getSystemId() +
                       "; Zeile " + ex.getLineNumber() + ": \n" + ex.getMessage());
  }
}

