package com.herdt.javxml.kap06;

import java.io.*;
import org.w3c.dom.*;
import org.xml.sax.SAXException;
import org.apache.xerces.parsers.*;

public class DOM3
{
  static Document doc;

  public DOM3()
  {
    DOMParser dom = new DOMParser();
    try
    {
      // Whitespaces unterdrcken
      dom.setFeature("http://apache.org/xml/features/dom/include-ignorable-whitespace", false);
      // keine Entity-Reference erstellen; Ausgabe der Entity-Referenz unterdrcken
      // dom.setFeature("http://apache.org/xml/features/dom/create-entity-ref-nodes", false);
      System.out.println("DOM-Implementierung: " + dom.getProperty("http://apache.org/xml/properties/dom/document-class-name"));
      dom.parse("com\\herdt\\javxml\\kap06\\Dichter.xml");
      doc = dom.getDocument();
      System.out.println("Strukturbaum der Datei dichter.xml vollstaendig aufgebaut\n");
    }
    catch(SAXException se)
    {
      System.out.println("Fehler beim Parsen: " + se.getMessage());
    }
    catch(IOException e)
    {
      System.out.println("E/A-Fehler: " + e.getMessage());
    }
  }

  public DOM3(int i)
  {
  }

  public static void main(String[] args)
  {
    DOM3 dom3 = new DOM3();
    dom3.anzeigen(doc, 1);
  }

  public void anzeigen(Node node, int stufe)
  {
    for(int i = 1; i < stufe; i++)
       System.out.print("  ");

    switch(node.getNodeType())
    {
      case Node.ATTRIBUTE_NODE:         System.out.print(node.getNodeName() + " = " + node.getNodeValue() + " ");
                                        if(!((Attr)node).getSpecified())
                                          System.out.print("(default) ");
                                        break;
      case Node.CDATA_SECTION_NODE:     System.out.print("CDATA: " + node.getNodeValue() + " ");
                                        break;
      case Node.COMMENT_NODE:           System.out.println("Kommentar: " + node.getNodeValue());
                                        break;
      case Node.DOCUMENT_FRAGMENT_NODE: System.out.println("Dokument-Fragment: " + node.getNodeValue());
                                        break;
      case Node.DOCUMENT_NODE:          System.out.println("Dokument: " + node.getNodeName());
                                        NodeList nl = node.getChildNodes();
                                        for(int i = 0; i < nl.getLength(); i++)
                                        {
                                          this.anzeigen(nl.item(i), ++stufe);
                                          stufe--;
                                        }
                                        break;
      case Node.DOCUMENT_TYPE_NODE:     System.out.println("Dokumenttyp: " + node.getNodeName() +
                                          ", SystemId: " + ((DocumentType)node).getSystemId());

                                        NamedNodeMap notations = ((DocumentType)node).getNotations();
                                        for(int i = 0; i < notations.getLength(); i++)
                                        {
                                          this.anzeigen(notations.item(i), ++stufe);
                                          stufe--;
                                          System.out.println();
                                        }
                                        // Entitys anzeigen
                                        NamedNodeMap entitys = ((DocumentType)node).getEntities();
                                        for(int i = 0; i < entitys.getLength(); i++)
                                        {                        
                                          this.anzeigen(entitys.item(i), ++stufe);
                                          stufe--;
                                          System.out.println();
                                        }
                                        break;
      case Node.ELEMENT_NODE:           System.out.println(node.getNodeName());
                                        NamedNodeMap attribs = node.getAttributes();
                                        for(int i = 0; i < attribs.getLength(); i++)
                                        {
                                          this.anzeigen(attribs.item(i), ++stufe);
                                          stufe--;
                                          System.out.println();
                                        }
                                        NodeList childs = node.getChildNodes();
                                        for(int i = 0; i < childs.getLength(); i++)
                                        {
                                          this.anzeigen(childs.item(i), ++stufe);
                                          stufe--;
                                        }
                                        break;
      case Node.ENTITY_NODE:            System.out.print("Entity: " + node.getNodeName() + ", SystemId: " + ((Entity)node).getSystemId());
                                        break;
      case Node.ENTITY_REFERENCE_NODE:  System.out.println("Entity-Reference: " +  node.getNodeName());
                                        this.anzeigen(node.getFirstChild(), ++stufe);
                                        stufe--;
                                        break;
      case Node.NOTATION_NODE:          System.out.println("Notation: " + node.getNodeValue());
                                        break;
      case Node.PROCESSING_INSTRUCTION_NODE: System.out.println("PI: " + node.getNodeName() + " " + node.getNodeValue());
                                        break;
      case Node.TEXT_NODE:              System.out.println("Text: " + node.getNodeValue());
                                        break;
    }
  }
}
