package com.herdt.javxml.kap07;

import org.w3c.dom.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import javax.xml.parsers.*;
import java.io.*;

public class IEDOMTransform
{
  private String media = null;
  private String title = null;
  private String charset = null;

  public IEDOMTransform()
  {
    try
    {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document d = db.parse(new File("IETrans.xml"));
      Node n = d.getDocumentElement();
      DOMSource ds = new DOMSource(n);

      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer t = tf.newTransformer(new StreamSource("IETrans.xsl"));
      t.transform(ds, new StreamResult(System.out));
    }
    catch(TransformerException e)
    {
      int lineNo;

      DOMLocator l = (DOMLocator)e.getLocator();
      if(l != null)
        lineNo = l.getLineNumber();
      else
        lineNo = 0;

      System.out.println("Fehler in Zeile " + lineNo + "\n" + e.getMessage());
    }
    catch(Exception e2)
    {
      System.out.println(e2.getMessage());
    }  
  }

  public static void main(String args[])
  {
    new IEDOMTransform();
  }
}
