package com.herdt.javxml.kap09;

import org.apache.cocoon.transformation.*;
import org.apache.avalon.framework.parameters.*;
import org.apache.cocoon.environment.*;
import org.apache.cocoon.*;
import org.xml.sax.*;
import java.util.*;
import java.io.*;

public class LowerCaseTransf extends AbstractTransformer
{
  public void setup(SourceResolver resolver, Map objectModel, String source,
                    Parameters parameters) throws ProcessingException, SAXException, IOException
  {
  }

  public void startElement(String uri, String name, String raw, Attributes attributes) throws SAXException
  {
    name = name.toLowerCase();
    uri  = uri.toLowerCase();
    raw  = raw.toLowerCase();
    super.contentHandler.startElement(uri,name,raw,attributes);
  }

  public void endElement(String uri,String name,String raw) throws SAXException
  {
    name = name.toLowerCase();
    uri  = uri.toLowerCase();
    raw  = raw.toLowerCase();
    super.contentHandler.endElement(uri,name,raw);
  }

  public void characters(char c[], int start, int len) throws SAXException
  {
    super.contentHandler.characters(c,start,len);
  }

  public void processingInstruction(String target, String data) throws SAXException 
  {
    super.contentHandler.processingInstruction(target, data);
  }

  public void startEntity(String name) throws SAXException 
  {
    super.lexicalHandler.startEntity(name);
  }

  public void endEntity(String name) throws SAXException 
  {
    super.lexicalHandler.endEntity( name);
  }

  public void startCDATA() throws SAXException 
  {
    super.lexicalHandler.startCDATA();
  }

  public void endCDATA() throws SAXException
  {
    super.lexicalHandler.endCDATA();
  }

  public void comment(char ch[], int start, int len) throws SAXException 
  {
    super.lexicalHandler.comment(ch, start, len);
  } 
}
